var datepiceker = (function() {
	function transformTime(d) {
		if (d && d.constructor == Date) {
			return d;
		}
		if (typeof d == 'string') {
			d.replace('-', '/');
			return new Date(d);
		}
		if (typeof d == 'number') {
			return new Date(d);
		}
		console.error('Failed to execute "transformTime" on Datepicker');
	}


	function Datepicker(option) {
		var opt = option || {};
		opt.cols = opt.cols || {};
		var dp = this,
			picker = null,
			voidFunc = function() {},
			today = new Date(),
			minDate, maxDate,
			curValue, prevValue;

		var indexOfCol = {
			'FullYear': 0,
			'Month': 1,
			'Date': 2,
			'Space': 3,
			'Hours': 4,
			'Divider': 5,
			'Minutes': 6
		}

		function getPickerDate(cols) {
			return new Date(
				cols[indexOfCol["FullYear"]].value,
				cols[indexOfCol["Month"]].value,
				cols[indexOfCol["Date"]].value,
				cols[indexOfCol["Hours"]].value,
				cols[indexOfCol["Minutes"]].value)
		}

		function dateToArray(date) {
			return [
				date.getFullYear(),
				date.getMonth(),
				date.getDate(),
				date.getHours(),
				date.getMinutes()
			]
		}


		this.min = function(min) {
			minDate = transformTime(min || opt.min || '1960/01/01 00:00:00');
		};
		this.max = function(max) {
			maxDate = transformTime(max || opt.max || '2030/01/01 00:00:00');
		};
		this.onChange = opt.onChange || voidFunc;
		var opt_format = null;
		// y-M-d h:m
		/*this.format = function(formatString) {
			var span = '_',
				formatArr = formatString.replace(/y|M|d|h|m/g, function(type) {
					return span + type + span
				}).replace(/^_|_$/g, '').split(span);
		};
		this.timerange = function() {

		}
		this.timespan = function(seconds) {

		}*/

		dp.min(opt.min);
		dp.max(opt.max);
		/**
		 * picker options
		 */
		var opt_change = function(picker, type, nextType) {
			var date = getPickerDate(picker.cols),
				min = minDate['get' + type](),
				max = maxDate['get' + type](),
				datetime = date.getTime(),
				mintime = minDate.getTime(),
				maxtime = maxDate.getTime()
			if (datetime < mintime && date['get' + type]() < min) {
				picker.cols[indexOfCol[type]].setValue(min)
				return;
			} else if (datetime > maxtime && date['get' + type]() > max) {
				picker.cols[indexOfCol[type]].setValue(max)
				return;
			}
			if (nextType && (datetime < mintime || datetime > maxtime)) {
				picker.cols[indexOfCol[nextType]].onChange(picker);
			}
		}
		var opt_years = {
			values: (function() {
				var min = minDate.getFullYear(),
					max = maxDate.getFullYear(),
					arr = [];
				for (var i = min; i <= max; i++) {
					arr.push(i)
				};
				return arr;
			})(),
			onChange: function(picker, value, displayValue) {
				opt_change(picker, 'FullYear', 'Month');
			}
		};
		// Months
		var opt_months = {
			values: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11],
			displayValues: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
			textAlign: 'right',
			onChange: function(picker, value, displayValue) {
				var daysInMonth = new Date(picker.cols[indexOfCol['FullYear']].value,
						parseInt(picker.cols[indexOfCol['Month']].value) + 1,
						0).getDate(),
					arr = [];
				for (var i = 1; i <= daysInMonth; i++) {
					arr.push(i);
				}
				if (picker.cols[indexOfCol['Date']].replaceValues) {
					picker.cols[indexOfCol['Date']].replaceValues(arr);
				}
				opt_change(picker, 'Month', 'Date');
			}
		};
		// Days
		var opt_day = {
			values: (function() {
				var lengthOfDaysInMonth = 31,
					arr = [];
				do {
					arr.unshift(lengthOfDaysInMonth);
				} while (lengthOfDaysInMonth--);
				return arr;
			})(),
			onChange: function(picker, value, displayValue) {
				opt_change(picker, 'Date', 'Hours');
			}
		};
		// Space divider
		var opt_space = {
			divider: true,
			content: '  '
		};
		// Hours
		var opt_hours = {
			values: (function() {
				var values = [],
					displayValues = [];
				for (var i = 0; i < 24; i++) {
					values.push(i);
					displayValues.push(i < 10 ? '0' + i : i);
				}
				return values;
			})(),
			onChange: function(picker) {
				opt_change(picker, 'Hours', 'Minutes');
			}
		};
		// Divider
		var opt_divider = {
			divider: true,
			textAlign: 'center',
			content: ':'
		};
		// Minutes、seconds
		var opt_minutes = {
			values: (function() {
				var values, i;
				if (opt.cols.minute) {
					values = opt.cols.minute.values;
				} else {
					for (i = 0, values = []; i < 60; i++) {
						values.push(i < 10 ? '0' + i : i);
					};
				}
				return values;
			})(),
			onChange: function(picker) {
				opt_change(picker, 'Minutes');
			}
		};
		/**
		 * init
		 */
		dp.picker = new Picker({
			container: opt.id,
			input: opt.input,
			rotateEffect: true,
			value: (function() {
				var d = transformTime(opt.value || minDate),
					minu = d.getMinutes();
				return [d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), minu < 10 ? '0' + minu : minu];
			})(),
			formatValue: function(p, values, displayValues) {
				var cols = p.cols;
				return cols[indexOfCol['FullYear']].value + '-' + (parseInt(cols[indexOfCol['Month']].value) + 1) + '-' + cols[indexOfCol['Date']].value + ' ' + cols[indexOfCol['Hours']].value + ':' + cols[indexOfCol['Minutes']].value;
			},
			onChange: function(picker, values, displayValues) {
				dp.onChange(picker, values, displayValues);
			},
			cols: [opt_years, opt_months, opt_day, opt_space, opt_hours, opt_divider, opt_minutes]
		});
	}

	return function(opt) {
		return new Datepicker(opt);
	}
})();