var datepiceker = (function() {
	function transformTime(d) {
		if (d && d.constructor == Date) {
			return d;
		}
		if (typeof d == 'string') {
			d.replace('-', '/');
			return new Date(d);
		}
		if (typeof d == 'number') {
			return new Date(d);
		}
		console.error('Failed to execute "transformTime" on Datepicker');
	}

	function Datepicker(option) {
		var opt = option || {};
		opt.cols = opt.cols || {};
		var dp = this,
			picker = null,
			voidFunc = function() {},
			today = new Date(),
			minDate, maxDate,
			currentValue;

		var indexOfCol = {
			year: 0,
			month: 1,
			date: 2,
			hour: 3,
			minute: 4
		}


		this.min = function(min) {
			minDate = transformTime(min || opt.min || '1960/01/01 00:00:00');
		};
		this.max = function(max) {
			maxDate = transformTime(max || opt.max || '2030/01/01 00:00:00');
		};
		this.onChange = opt.onChange || voidFunc;
		var opt_format = null;
		// y-M-d h:m
		/*this.format = function(formatString) {
			var span = '_',
				formatArr = formatString.replace(/y|M|d|h|m/g, function(type) {
					return span + type + span
				}).replace(/^_|_$/g, '').split(span);
		};
		this.timerange = function() {

		}
		this.timespan = function(seconds) {

		}*/

		dp.min(opt.min);
		dp.max(opt.max);
		/**
		 * picker options
		 */
		var opt_change = function(picker, values, displayValues) {
			var time = new Date(values[indexOfCol['year']], values[indexOfCol['month']] - 1, values[indexOfCol['date']], values[indexOfCol['hour']], values[indexOfCol['minute']]).getTime();
			debugger;
			if (time < minDate.getTime()) {
				picker.setValue([minDate.getFullYear(), minDate.getMonth() + 1, minDate.getDate(), minDate.getHours(), minDate.getMinutes()])
			} else if (time > maxDate.getTime()) {
				picker.setValue([maxDate.getFullYear(), maxDate.getMonth() + 1, maxDate.getDate(), maxDate.getHours(), maxDate.getMinutes()])
			};
			if (currentValue !== values.join('')) {
				dp.onChange(dp, values, displayValues);
			}
			currentValue = values.join('');
		};
		var opt_years = {
			values: (function() {
				var min = minDate.getFullYear(),
					max = maxDate.getFullYear(),
					arr = [];
				for (var i = min; i <= max; i++) {
					arr.push(i)
				};
				return arr;
			})(),
			onChange: function(picker, value, displayValue) {
				if (picker.cols[indexOfCol["month"]].value == 2) {
					picker.cols[indexOfCol["month"]].onChange(picker, 2)
				}
			}
		};
		// Months
		var opt_months = {
			values: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
			displayValues: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
			textAlign: 'right',
			onChange: function(picker, value, displayValue) {
				var daysInMonth = new Date(picker.cols[indexOfCol["year"]].value, picker.cols[indexOfCol["month"]].value, 0).getDate(),
					arr = [];
				for (var i = 1; i <= daysInMonth; i++) {
					arr.push(i);
				}
				if (picker.cols[indexOfCol["date"]].replaceValues) {
					picker.cols[indexOfCol["date"]].replaceValues(arr);
				}
			}
		};
		// Days
		var opt_day = {
			values: (function() {
				var lengthOfDaysInMonth = 31,
					arr = [];
				do {
					arr.unshift(lengthOfDaysInMonth);
				} while (lengthOfDaysInMonth--);
				return arr;
			})(),
			onChange: function(picker, value, displayValue) {
				/*var daysInMonth = new Date(picker.cols[indexOfCol["year"]].value, picker.cols[indexOfCol["month"]].value , 0).getDate(),
					arr = [];
				if (daysInMonth < value) {
					picker.cols[indexOfCol["date"]].setValue(daysInMonth)
				}*/
			}
		};
		// Space divider
		var opt_space = {
			divider: true,
			content: '  '
		};
		// Hours
		var opt_hours = (function() {
			var values = [],
				displayValues = [];
			for (var i = 0; i < 24; i++) {
				values.push(i);
				displayValues.push(i < 10 ? '0' + i : i);
			}
			return {
				values: values,
				displayValues: displayValues
			}
		})();
		// Divider
		var opt_divider = {
			divider: true,
			textAlign: 'center',
			content: ':'
		};
		// Minutes、seconds
		var opt_minutes = (function() {
			var values, i;
			if (opt.cols.minute) {
				values = opt.cols.minute.values;
			} else {
				for (i = 0, values = []; i < 60; i++) {
					values.push(i < 10 ? '0' + i : i);
				};
			}
			return {
				values: values
			}
		})();
		/**
		 * init
		 */
		dp.picker = new Picker({
			container: opt.id,
			input: opt.input,
			rotateEffect: true,
			value: (function() {
				var d = transformTime(opt.value || minDate),
					minu = d.getMinutes();
				return [d.getFullYear(), d.getMonth() + 1, d.getDate(), d.getHours(), minu < 10 ? '0' + minu : minu];
			})(),
			formatValue: function(p, values, displayValues) {
				return displayValues[0] + '-' + values[1] + '-' + values[2] + ' ' + values[3] + ':' + values[4];
			},
			onChange: opt_change,
			cols: [opt_years, opt_months, opt_day, opt_space, opt_hours, opt_divider, opt_minutes]
		});
	}

	return function(opt) {
		return new Datepicker(opt);
	}
})();